#include <stdio.h>
#define N 8
#define bool int
#define true 1
#define false 0

int count = 0;

void display(int * solution) {
  int i,j,k;
  for (i = 1; i <= N; i++) {
    for (j = 1; j < solution[i]; j++) printf(".");
    printf("Q");
    for (j = solution[i]+1; j <= N; j++) printf(".");
    printf("\n");
  }
  printf("\n");
  count++;
}

int down(int i, int j) {
  return j-i+N-1;
}

int up(int i, int j) {
  return i+j-1;
}

void place_queen (int i, int j, int * sol, int * cols, int * downs, int * ups) {
  sol[i] = j;
  cols[j] = false;
  downs[down(i,j)] = false;
  ups[up(i,j)] = false;  
}

void remove_queen (int i, int j, int * cols, int * downs, int * ups) {
  cols[j] = true;
  downs[down(i,j)] = true;
  ups[up(i,j)] = true;  
}

void queens (int i, int * sol, int * cols, int * downs, int * ups) {
  int j;
  if (i == N+1) {
    display(sol);
  } else {
    for (j=1; j<=N; j++) {
      if (cols[j] && downs[down(i,j)] && ups[up(i,j)]) {
        place_queen(i,j,sol,cols,downs,ups);
        queens(i+1,sol,cols,downs,ups);
        remove_queen(i,j,cols,downs,ups);
      }
    }
  }
}

void main() {
  int sol[N+2];
  bool cols[N+1], downs[2*N], ups[2*N];
  int i;
  for (i = 0; i <= N; i++) {
    cols[i] = true;
  }
  for (i = 0; i < 2*N; i++) {
    downs[i] = true;
    ups[i] = true;
  }
  queens(1,sol,cols,downs,ups);
  printf("Número de soluciones: %d\n",count);
}

